<template>
  <div class="py-0 px-4 ml-0 relative my-0 mx-auto max-w-full w-full">
    <div class="overflow-hidden pt-8 py-4 px-0 pb-20 min-h-[calc(50vh-72px)]">
      <div>
        <div class="py-0 px-4 my-0 mx-auto max-w-full w-ful">
          <div
            class="p-0 w-[540px] max-w-full my-0 mx-auto rounded-[40px] relative"
          >
            <div
              class="flex justify-start mb-6 relative items-center flex-wrap"
            >
              <h2
                class="text-2xl w-auto m-0 font-bold text-[var(--title-font-color)]"
              >
                {{ $t("capital_login") }}
              </h2>
            </div>
            <div>
              <el-form
                ref="loginFormRef"
                label-position="top"
                :model="loginFormData"
                :rules="loginRules"
                :validate-on-rule-change="false"
                class="w-full mx-auto"
              >
                <el-form-item :label="$t('username')">
                  <el-input
                    v-model="loginFormData.Username"
                    :placeholder="$t('username')"
                    type="text"
                  />
                </el-form-item>
                <el-form-item :label="$t('password')">
                  <el-input
                    v-model="loginFormData.Password"
                    :placeholder="$t('password')"
                    type="password"
                  />
                </el-form-item>
                <div class="btn-click-captcha-to-verify">
                  <el-form-item
                    v-if="!clientCaptcha.IsHidden"
                    prop="Captcha"
                    :show-message="true"
                  >
                    <div id="captcha-button">
                      <div id="captcha-pop-up-verify" class="w-full">
                        <template
                          v-if="
                            !captchaErrorMsg.length &&
                            loginFormData.Captcha.length == 5 &&
                            !isDialogVisible
                          "
                        >
                          <div class="relative w-[18px] h-[18px]">
                            <img
                              :src="
                                getAssetImage(
                                  'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                                )
                              "
                              alt="verify icon success"
                              loading="lazy"
                            />
                          </div>
                          <span class="whitespace-nowrap text-[#18a452]">{{
                            $t("successful_verification")
                          }}</span>
                        </template>
                        <template v-else>
                          <div
                            class="flex justify-start items-center gap-1 w-full"
                            @click="isDialogVisible = true"
                          >
                            <div class="relative w-[18px] h-[18px]">
                              <img
                                :src="
                                  getAssetImage(
                                    'assets/theme/light_flexible_1/desktop/images/verify-icon.png'
                                  )
                                "
                                alt="verify icon"
                                loading="lazy"
                              />
                            </div>
                            <span class="text-[var(--title-font-color)]">{{
                              $t("click_to_verify")
                            }}</span>
                          </div>
                        </template>
                      </div>
                    </div>
                  </el-form-item>
                </div>
                <el-form-item class="forgot-password-form-item">
                  <auth-forgot-password-modal :fullscreen="true" />
                </el-form-item>
                <div
                  class="h-[1px] bg-[var(--border-color)] w-full mb-[25px]"
                ></div>
                <template class="flex justify-center">
                  <div class="">
                    <el-button
                      :loading="isLoginProccessing"
                      :disabled="isLoginProccessing"
                      type="danger"
                      round
                      @click="submitLogin(loginFormRef)"
                      >{{ $t("submit") }}</el-button
                    >

                    <theme-common-telegram-login-button
                      :is-show="isTelegramBotSetup"
                      :username="telegramBotUsername"
                      @callback="telegramCallbackFunction"
                    />
                  </div>
                </template>
                <p
                  v-if="!register.IsHidden"
                  class="w-full mt-6 text-base text-[#707585] text-center"
                >
                  {{ $t("you_do_not_have_account_yet") }}?
                  <nuxt-link
                    class="text-[var(--accent-color)] relative ml-[10px]"
                    to="/register"
                    :id="ID.SIGNUP"
                    >{{ $t("create_account") }}</nuxt-link
                  >
                </p>
              </el-form>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="captcha-dialog-container">
      <el-dialog
        v-model="isDialogVisible"
        align-center
        destroy-on-close
        :show-close="false"
        custom-class="p-[15px] captcha-dialog"
        width="320px"
        @open="loginFormData.Captcha = ''"
        @close="loginFormRef?.validateField('Captcha')"
      >
        <utils-client-captcha
          v-if="!clientCaptcha.IsHidden"
          v-model:captcha="loginFormData.Captcha"
          v-model:dialogVisible="isDialogVisible"
          :get-error-message="getCaptchaErrorMsg"
          :is-invalid="captchaErrorMsg.length > 0"
        />
      </el-dialog>
    </div>
  </div>
</template>

<script lang="ts">
import useLogin from "@/composables/useLogin";
import { clientCaptcha } from "@/composables/captcha/useCaptcha";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  name: "Login",
  setup() {
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      register,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
      checkLoginTelegramSetup,
    } = useLogin();
    checkLoginTelegramSetup();
    const isDialogVisible = ref(false);
    const { getAssetImage } = commonHelper;
    return {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      isDialogVisible,
      clientCaptcha,
      getAssetImage,
      register,
      isTelegramBotSetup,
      telegramBotUsername,
      telegramCallbackFunction,
    };
  },
});
</script>

<style scoped>
:deep(.el-input__inner) {
  height: 40px;
  width: 100%;
  padding: 8px 16px;
  font-family: Roboto, sans-serif;
  font-size: 14px;
  font-weight: 400;
  line-height: 20px;
  color: var(--title-font-color);
  background: var(--background-body);
  border: 1px solid transparent;
  box-shadow: var(--box-shadow-inset);
  border-radius: 8px;
  box-sizing: border-box;
}
:deep(button.el-button) {
  background-color: var(--button-bg) !important;
  color: #707585 !important;
  opacity: unset !important;
  box-shadow: var(--box-shadow);
  display: inline-flex;
  align-items: center;
  justify-content: center;
  height: 40px;
  font-size: 14px;
  box-sizing: border-box;
  text-align: center;
  user-select: none;
  padding: 0 20px;
  white-space: nowrap;
  overflow: hidden;
  font-weight: 600;
  text-decoration: none;
  transition: all 0.5s;
  border-radius: 6px;
  border: none;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4 uppercase;
}
.common-layout #captcha-button {
  height: 40px;
  width: 100%;
  padding: 8px 16px;
  font-family: Roboto, sans-serif;
  font-size: 14px;
  font-weight: 400;
  line-height: 20px;
  color: var(--title-font-color);
  background: var(--background-body);
  border: 1px solid transparent;
  box-shadow: var(--box-shadow-inset);
  border-radius: 8px;
  box-sizing: border-box;
}
.common-layout #captcha-pop-up-verify {
  justify-content: start;
}
.common-layout .captcha-dialog-container {
  --captcha-dialog-border-top-color: var(--primary-fallback);
  --captcha-button-color: var(--primary-fallback);
  --captcha-loading-color: var(--primary-fallback);
  --captcha-submit-button-color: var(--primary-fallback);
  --captcha-submit-button-text-color: #fff;
}
</style>
